library(Asp)
asp.dbConnect("mclatentonline","ralmond")

online <- daCapo(window=c(1000,6000))

daCapoApplyPrint(online,summary)

oparams <- unlist(c(online$stu,online$link),recursive=FALSE)

lapply(oparams, function (m) {gelman.diag(m[,1],transform=TRUE)})
gelman.diag(iparams[[4]],transform=TRUE)

lapply(oparams, function (m) {autocorr.diag(m[,1],lags=5)})

maxRNC(unlist(online$linkModels,recursive=FALSE))


lam0o <- getAllParameters("lc2",iterations=c(1,2000))
lam0o <- lam0o[[1]][,1]
traceAutoplot(lam0o)
gelman.plot(lam0o)


## Paste them all together into one big table for convenience
lc2o <- oparams[[1]][,1]
#varnames(oparams) <- "theta"
Item1o <- oparams[[2]][,c(3,1)]
varnames(Item1o) <- c("pi.10","pi.11")
Item4o <- oparams[[4]][,c(3,1)]
varnames(Item4o) <- c("pi.40","pi.41")
Item3o <- oparams[[3]][,6:1]
varnames(Item3o) <- c("pi.300","pi.301", "pi.302","pi.310","pi.311","pi.312")

allmcmc <- lapply(1:nchain(lc2o), function(chain) {
  mcmc(cbind(lambda=lc2o[[chain]], Item1o[[chain]],
             Item3o[[chain]], Item4o[[chain]]),
       start=start(lc2o), end=end(lc2o), thin=thin(lc2o))
})
allOnlineParams <- do.call("mcmc.list",allmcmc)
sumOnline <- summary(allOnlineParams)

library(xtable)
xtable(allOnlineParams[[1]][1000*(0:5)+1,],digits=rep(2,12))
xtable(t(sumOnline$stat),digits=rep(3,12))
xtable(t(sumOnline$q),digits=rep(2,12))

selectedOnlineParams <- allOnlineParams[,c(1,3,4:6,10)]

selectedOnlinePooled <- mcmc(rbind(selectedOnlineParams[[1]],
                              selectedOnlineParams[[2]],
                              selectedOnlineParams[[3]]))

pdf("../figs/MCOnlinePost.pdf",width=3.5,height=4.5)
par(mfrow=c(3,2))
densplot(selectedOnlinePooled,ylim=c(0,5.5))
dev.off()
system("open ../figs/MCOnlinePost.pdf")

postscript("../figs/MCOnlinePost.eps",width=3.5,height=4.5,
    onefile=FALSE,paper="special",horizontal=FALSE)
par(mfrow=c(3,2))
densplot(selectedOnlinePooled,ylim=c(0,5.5))
dev.off()
system("open ../figs/MCOnlinePost.eps")

